unit Magvari1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask, Menus, MagVari2, MagVari3;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    GroupBox1: TGroupBox;
    MaskEdit3: TMaskEdit;
    MaskEdit4: TMaskEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    MaskEdit5: TMaskEdit;
    MaskEdit6: TMaskEdit;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    GroupBox3: TGroupBox;
    MaskEdit7: TMaskEdit;
    Label8: TLabel;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    GroupBox5: TGroupBox;
    Label10: TLabel;
    GroupBox6: TGroupBox;
    Label11: TLabel;
    GroupBox7: TGroupBox;
    Label12: TLabel;
    GroupBox8: TGroupBox;
    Label13: TLabel;
    GroupBox9: TGroupBox;
    Label14: TLabel;
    GroupBox10: TGroupBox;
    Label15: TLabel;
    SeeMap1: TMenuItem;
    Label16: TLabel;
    procedure ChgDateFmt;
    function Controlls: Boolean;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MaskEdit1Change(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SeeMap1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Param = Record
    OK: Char;
    Variation,
    B_r: Real;
    B_theta: Real;
    B_phi: Real;
    B_x: Real;
    B_y: Real;
    B_z: Real;
end;

XFile = Array[0..255] of Char;
XDate = Array[0..10] of Char;

var
  Form1: TForm1;
  Anno, Mese, Giorno: Word;
  FileModel: String;
  ToBePassed: Param;
  ForTheDate: XDate;
  FileModelNull: XFile;
  Lat, Lon: Real;

const
  ErrorMessage1 = 'Value or format invalid';
  ErrorMessage2 = 'Model file invalid';
  ErrorMessage3 = 'Data error';

implementation

{$R *.DFM}

Function MagVarC(PDate: XDate; Lat, Lon, Alt: Real; FileModel: XFile): Param;
  far; external 'MagVar.DLL';

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.ClientHeight := GroupBox10.Top + GroupBox10.Height + 10;
  Form1.ClientWidth := GroupBox3.Left + GroupBox3.Width + 10;
  ChgDateFmt; {Force year to 4 digits in date format}
  MaskEdit2.Text := DateToStr(Now);
  DecodeDate(Now, Anno, Mese, Giorno);
  MaskEdit1.Text := IntToStr(Anno);
  MaskEdit3.Text := '00';
  MaskEdit4.Text := FormatFloat('000.000', 0.0);
  MaskEdit5.Text := '000';
  MaskEdit6.Text := MaskEdit4.Text;
  MaskEdit7.Text := '000';
  ComboBox1.ItemIndex := 0;
end;

procedure TForm1.MaskEdit1Change(Sender: TObject);
begin
  MaskEdit1.OnChange := nil;
  try
    Anno := StrToInt(MaskEdit1.Text);
    if Anno < 1000 then Anno := StrToInt('a');
    Anno := Anno div 5;
    Anno := Anno * 5;
    MaskEdit1.Text := IntToStr(Anno);
    Button1.SetFocus;
  except end;
  MaskEDit1.OnChange := MaskEdit1Change;
end;

function TForm1.Controlls: Boolean;
var
  Datum: TDateTime;
begin
  {Controls}
  Result := False;
  try
    Datum := StrToDate(MaskEdit2.Text);
  except
    MaskEdit2.SetFocus;
    MessageDlg(ErrorMessage1, mtError, [mbOK], 0);
    exit;
  end;

  try
    Lat := StrToInt(MaskEdit3.Text);
    if Lat > 90 then Lat := StrToInt(Button1.Caption);
  except
    MaskEdit3.SetFocus;
    MessageDlg(ErrorMessage1, mtError, [mbOK], 0);
    exit;
  end;

  try
    Lat := StrToFloat(MaskEdit4.Text);
    if (Lat > 60) or (Lat < 0) then Lat := StrToInt(Button1.Caption);
    Lat := Lat /60 + StrToInt(MaskEdit3.Text);
    if Lat > 90 then Lat := StrToInt(Button1.Caption);
  except
    MaskEdit4.SetFocus;
    MessageDlg(ErrorMessage1, mtError, [mbOK], 0);
    exit;
  end;

  try
    Lon := StrToInt(MaskEdit5.Text);
    if Lon > 180 then Lon := StrToInt(Button1.Caption);
  except
    MaskEdit5.SetFocus;
    MessageDlg(ErrorMessage1, mtError, [mbOK], 0);
    exit;
  end;

  try
    Lon := StrToFloat(MaskEdit6.Text);
    if (Lon > 60) or (Lon < 0) then Lon := StrToInt(Button1.Caption);
    Lon := Lon / 60 + StrToInt(MaskEdit5.Text);
    if Lon > 180 then Lon := StrToInt(Button1.Caption);
  except
    MaskEdit6.SetFocus;
    MessageDlg(ErrorMessage1, mtError, [mbOK], 0);
    exit;
  end;
  Result := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  EorW: String[2];
begin
  if Controlls = False then exit;

  if RadioButton2.Checked = True then Lat := Lat * -1;
  if RadioButton4.Checked = True then Lon := Lon * -1;

  {call DLL}
  FileModel := ExtractFilePath(Paramstr(0)) +
    ComboBox1.Text + MaskEdit1.Text + '.MD';
  StrPCopy(FileModelNull, FileModel);
  StrPCopy(ForTheDate, MaskEdit2.Text);

  ToBePassed := MagVarC(ForTheDate, Lat, Lon, StrToInt(MaskEdit7.Text),
    FileModelNull);

  if ToBePassed.OK = '0' then begin  { if all is OK}
    if ToBePassed.Variation < 0 then EorW := ' W' else EorW := ' E';

    Label9.Caption := FormatFloat('##0.0', Abs(ToBePassed.Variation)) + EorW;

    Label10.Caption := FormatFloat('######0.0', ToBePassed.B_r);
    Label11.Caption := FormatFloat('######0.0', ToBePassed.B_Theta);
    Label12.Caption := FormatFloat('######0.0', ToBePassed.B_Phi);

    Label13.Caption := FormatFloat('######0.0', ToBePassed.B_x);
    Label14.Caption := FormatFloat('######0.0', ToBePassed.B_y);
    Label15.Caption := FormatFloat('######0.0', ToBePassed.B_z);
  end;

  if ToBePassed.OK = '1' then
    MessageDlg(ErrorMessage2, mtError, [mbOK], 0);

  if ToBePassed.OK > '1' then
    MessageDlg(ErrorMessage3, mtError, [mbOK], 0);
end;

procedure TForm1.ChgDateFmt; {Force year to 4 digits in date format}
var
  S: String[15];
begin
  S := ShortDateFormat;

  {Convert to  right case if needed}
  while Pos('Y', S) > 0 do
    S[Pos('Y', S)] := 'y';

  while Pos('m', S) > 0 do
    S[Pos('m', S)] := 'M';

  while Pos('D', S) > 0 do
    S[Pos('D', S)] := 'd';

  {if error then exit}
  if Pos('y', S) = 0 then exit;
  if pos('M', S) = 0 then exit;
  if Pos('d', S) = 0 then exit;

  {insert until 4 * y}
  while Pos('yyyy', S) = 0 do
  Insert('y', S, Pos('y', S));

  {insert until 2 * M}
  while Pos('MM', S) = 0 do
  Insert('M', S, Pos('M', S));

  {insert until 2 * d}
  while Pos('dd', S) = 0 do
  Insert('d', S, Pos('d', S));

  ShortDateFormat := S;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MaskEdit3.SetFocus;
end;

procedure TForm1.SeeMap1Click(Sender: TObject);
begin
  if Controlls = True then Form3.ShowModal;
end;

end.
